class Union {}

const ENTITY_KEY = Symbol("entity");
function Entity(options) {
  return function (target, propertyKey) {
    const entityMap = Reflect.getMetadata(ENTITY_KEY, target.constructor) ?? new Map();
    if (!entityMap.has(propertyKey)) {
      entityMap.set(propertyKey, {
        parentEntityHolder: false,
        ...options
      });
      Reflect.defineMetadata(ENTITY_KEY, entityMap, target.constructor);
    }
  };
}
function HasEntity() {
  return function (target, propertyKey) {
    const entityMap = Reflect.getMetadata(ENTITY_KEY, target.constructor) ?? new Map();
    if (!entityMap.has(propertyKey)) {
      entityMap.set(propertyKey, {
        parentEntityHolder: true
      });
      Reflect.defineMetadata(ENTITY_KEY, entityMap, target.constructor);
    }
  };
}

export { ENTITY_KEY as E, HasEntity as H, Union as U, Entity as a };
